{$I DEFINE.INC}
unit Graph3d;
interface
uses Ext_Math;
type
  TPoint3d = record
    X,Y,Z:Double;
  end;

function Cilindr(F,S:TPoint3d; R:Double; T11,TF:TPoint3d; var GOT, NorA:TPoint3d):boolean;
implementation

function Cilindr(F,S:TPoint3d; R:Double; T11,TF:TPoint3d; var GOT, NorA:TPoint3d):boolean;
var
  n,i,j,jop:integer;
  ABC:TPoint3d;
  xz,yz,xx,yy,Lola,stom,A,B,C:Double;
begin
  Cilindr:=false;
  n:=4;
  Who[1]:=0; Who[2]:=0; Who[3]:=1; Who[4]:=1;
  ABC.X:=S.X-F.X; ABC.Y:=S.Y-F.Y; ABC.Z:=S.Z-F.Z;
  Lola:=Sqrt(Sqr(ABC.X)+Sqr(ABC.Y)+Sqr(ABC.Z));
  ABC.X:=ABC.X/Lola; ABC.Y:=ABC.Y/Lola; ABC.Z:=ABC.Z/Lola;
  XX:=T11.X-F.X; YY:=T11.Y-F.Y;
  XZ:=(T11.X-TF.X)/(T11.Z-TF.Z);
  YZ:=(T11.Y-TF.Y)/(T11.Z-TF.Z);
  Lola:=ABC.X*XZ+ABC.Y*YZ+ABC.Z;
  Stom:=-T11.Z*(ABC.X*XZ+ABC.Y*YZ)-ABC.Z*F.Z+ABC.X*XX+ABC.Y*YY;
  A:=Sqr(XZ)+Sqr(YZ)+1-Sqr(Lola);
  if A=0 then exit;
  B:=2*(-Sqr(XZ)*T11.Z+XZ*XX-Sqr(YZ)*T11.Z+YZ*YY-F.Z-Lola*Stom);
  C:=Sqr(XZ*T11.Z-XX)+Sqr(YZ*T11.Z-YY)+Sqr(F.Z)-Sqr(Stom)-Sqr(R);
  if Kvadr(A,B,C,P1[1,3],P1[2,3])=kvNoX then exit;
  Fir[1,1]:=ABC.X; Fir[2, 1]:=ABC.Y; Fir[3, 1]:=ABC.Y;
  Fir[4.1:=-ABC.X*F.X-ABC.Y*F.Y-ABC.Z*F.Z;
  for i:=1 to 4 do
      Sek[i.1]:=-Fir[i,1];
end;

end.
