unit DAE_Type;
interface
const
  {TCodePageDrv consts}
  cpWin               = 1251;
  cpDos               = 866;
  cpKoi8              = $38696F4B;

const    {Version of DBF files}
  verNone             = $00;
  verDBase2           = $02;
  verDBase3           = $03;
  verDBase3Memo       = $83;
  verDBase4Memo       = $8B;
  verFoxPro2XMemo     = $F5;
  verDBase7           = $04;
  verDBase7Memo       = $8C;
  verVFP              = $30;

const    {Codepage flags}
   dbfCP_437     = $01;
   dbfCP_850     = $02;
   dbfCP_1251    = $03;  { codepage 1251 Windows ANSI }
   dbfCP_1250    = $C8;  { codepage 1250 Windows EE   }
   dbfCPIgnored  = $00;

type
   TDataSetStatusRecord = record
     fEof : Boolean;
     fBof : Boolean;
   end;
type
  TPageRec = record
    Ref:longint;
    CurItem:integer;
  end;

  TPagePtrArray = array [1..20] of TPageRec;

type
  TDBaseFunc = (funError, funStr, funDtoS);

type
  TPageRecord = record
    LeftPage:Longint;
    PtrRecord:Longint;
    Key:array [1..255] of char;
  end;
const
  FVPDateDiff     = 2415019;

implementation

end.
