{       }
{       }

{$IFDEF VER70}
{$O+} {$I CompiOpt.inc}
{$ENDIF}

unit PriceTOS;
interface
const
{$IFDEF TARGET_DOS}
   Kop1       = '';
   Kop2_4     = '';
   Kop5_0     = '';
   Rub1       = '㡫';
   Rub2_4     = '㡫';
   Rub5_0     = '㡫';
   Rub1000    = ' ';
   Rub2_4000  = ' ';
   Rub5_0000  = ' ';
   RM1        = ' ';
   RM2_4      = ' ';
   RM5_0      = ' ';
   RMM1       = ' ';
   RMM2_4     = 'ठ ';
   RMM5_0     = 'म ';
   t100       = ' ';
   t200       = ' ';
   t300       = ' ';
   t400       = ' ';
   t500       = ' ';
   t600       = ' ';
   t700       = 'ᥬ ';
   t800       = 'ᥬ ';
   t900       = ' ';
   t10        = ' ';
   t11        = ' ';
   t12        = ' ';
   t13        = 'ਭ ';
   t14        = 'ୠ ';
   t15        = '⭠ ';
   t16        = '⭠ ';
   t17        = 'ᥬ ';
   t18        = 'ᥬ ';
   t19        = '⭠ ';
   t20        = ' ';
   t30        = 'ਤ ';
   t40        = 'ப ';
   t50        = '줥 ';
   t60        = '줥 ';
   t70        = 'ᥬ줥 ';
   t80        = 'ᥬ줥 ';
   t90        = 'ﭮ ';
   t1         = ' ';
   t1000      = ' ';
   t2         = ' ';
   t2000      = ' ';
   t3         = ' ';
   t4         = ' ';
   t5         = ' ';
   t6         = ' ';
   t7         = 'ᥬ ';
   t8         = 'ᥬ ';
   t9         = ' ';
{$ELSE}
   Zerro      = '';
   Kop1       = '';
   Kop2_4     = '';
   Kop5_0     = '';
   Rub1       = '';
   Rub2_4     = '';
   Rub5_0     = '';
   Rub1000    = ' ';
   Rub2_4000  = ' ';
   Rub5_0000  = ' ';
   RM1        = ' ';
   RM2_4      = ' ';
   RM5_0      = ' ';
   RMM1       = ' ';
   RMM2_4     = ' ';
   RMM5_0     = ' ';
   t100       = ' ';
   t200       = ' ';
   t300       = ' ';
   t400       = ' ';
   t500       = ' ';
   t600       = ' ';
   t700       = ' ';
   t800       = ' ';
   t900       = ' ';
   t10        = ' ';
   t11        = ' ';
   t12        = ' ';
   t13        = ' ';
   t14        = ' ';
   t15        = ' ';
   t16        = ' ';
   t17        = ' ';
   t18        = ' ';
   t19        = ' ';
   t20        = ' ';
   t30        = ' ';
   t40        = ' ';
   t50        = ' ';
   t60        = ' ';
   t70        = ' ';
   t80        = ' ';
   t90        = ' ';
   t1         = ' ';
   t1000      = ' ';
   t2         = ' ';
   t2000      = ' ';
   t3         = ' ';
   t4         = ' ';
   t5         = ' ';
   t6         = ' ';
   t7         = ' ';
   t8         = ' ';
   t9         = ' ';
{$ENDIF}

function Mul(Many,Price:LongInt):Longint;
Function Per(Total,Percent:Longint):Double;
Function Sum(One,Two:Double):Double;
Function Convert3Bits(Dig:Longint;Thousand:Boolean):String;

function PriceToString(Sum:Double; PrintKoopZero, IsCurrency:boolean):string;

implementation

{$IFDEF TARGET_DOS}
uses Ext_Math;
{$ELSE}
uses SysUtils;
{$ENDIF}

function Mul(Many,Price:LongInt):Longint;
begin
  Mul:=Many*Price;
end;

Function Per(Total,Percent:Longint):Double;
begin
  Per:=(Total/100)*Percent;
end;

Function Sum(One,Two:Double):Double;
begin
 Sum:=One+Two;
end;

function Convert3Bits(Dig:Longint;Thousand:Boolean):String;
var A,B,C:Longint;
{     }
{   ࠧ ன ᥫ}
    T:string;
begin
  C:=Dig-trunc(Dig/10)*10;
  B:=Trunc(Dig/10-Trunc(Dig/100)*10);
  A:=trunc((Dig-B*10-C)/100);
  T:='';
  case A of
     1: T:=t100;
     2: T:=t200;
     3: T:=t300;
     4: T:=t400;
     5: T:=t500;
     6: T:=t600;
     7: T:=t700;
     8: T:=t800;
     9: T:=t900;
  end;
  case B of
     1:Case C of
            0: T:=T+t10;
            1: T:=T+t11;
            2: T:=T+t12;
            3: T:=T+t13;
            4: T:=T+t14;
            5: T:=T+t15;
            6: T:=T+t16;
            7: T:=T+t17;
            8: T:=T+t18;
            9: T:=T+t19;
       end;
     2: T:=T+t20;
     3: T:=T+t30;
     4: T:=T+t40;
     5: T:=T+t50;
     6: T:=T+t60;
     7: T:=T+t70;
     8: T:=T+t80;
     9: T:=T+t90;
  end;
  if B<>1 then case C of
     1: if thousand then T:=T+t1000
                    else T:=T+t1;

     2: if thousand then T:=T+t2000
                    else T:=T+t2;
     3: T:=T+t3;
     4: T:=T+t4;
     5: T:=T+t5;
     6: T:=T+t6;
     7: T:=T+t7;
     8: T:=T+t8;
     9: T:=T+t9;
  end;
  Convert3Bits:=T;
end;

const
  NamesSumsArray : array [1..4,1..3] of string =
  ((Rub1,    Rub2_4,    Rub5_0),
   (Rub1000, Rub2_4000, Rub5_0000),
   (RM1,     RM2_4,     RM5_0),
   (RMM1,    RMM2_4,    RMM5_0));

function PriceToString(Sum:Double; PrintKoopZero, IsCurrency:boolean):string;
var i:integer;
    Koop:integer;
    S1:string;

function CalcKoop:string;
begin
  Koop:=Trunc((Sum-Int(Sum)+0.005)*100);
  if Koop<>0 then
  begin
    Result:=Result+IntToStr(Koop);
    if (Koop<10) and (PrintKoopZero) then Result:='0'+Result;
    Result:=' '+Result;
    if Koop div 10 = 1 then Result:=Result+' '+Kop5_0
    else
    case Koop mod 10 of
      1:Result:=Result+' '+Kop1;
      2..4:Result:=Result+' '+Kop2_4;
    else
      Result:=Result+' '+Kop5_0;
    end;
  end
  else
  begin
    if PrintKoopZero then Result:=' 00 '+Kop5_0;
  end;
end;

begin
  i:=0;
  Result:='';
  if IsCurrency then Result:=Result+CalcKoop;
  Sum:=int(Sum);
  while (i<4) and (Sum>0) do
  begin
    inc(i);
    Koop:=Trunc(Sum-(int(Sum/1000)*1000));
    Sum:=int(Sum/1000);
    if Koop<>0 then
    begin
      S1:=Convert3Bits(Koop, i=2);
      if (i=1) and ((Koop mod 100) in [11..19]) then
      begin
        if IsCurrency then
          Result:=S1+Rub5_0+Result
      end
      else
      begin
        case Koop mod 10 of
          1   : Result:=S1+NamesSumsArray[i,1]+Result;
          2..4: Result:=S1+NamesSumsArray[i,2]+Result;
        else
          Result:=S1+NamesSumsArray[i,3]+Result;
        end;
      end;
    end;
  end;
{$IFDEF TARGET_DOS}
  PriceToString:=stUpCase(Result[1])+Copy(Result,2,Length(Result));
{$ELSE}
  PriceToString:=AnsiUpperCase(Result[1])+Copy(Result,2,Length(Result));
{$ENDIF}
end;

(*function PriceToString(Sum:Double; PrintKoopZero:boolean):string;
var S,S1:string;
    Kop:Integer;
begin
  S:='';
  Kop:=Trunc((Sum-Int(Sum)+0.005)*100);
  Sum:=int(Sum);
  if Kop<>0 then
  begin
    S:=S+IntToStr(Kop);
    if (Kop<10) and (PrintKoopZero) then S:='0'+S;
    S:=' '+S;
    if Kop div 10 = 1 then
       S:=S+' '+Kop5_0
    else
       case Kop mod 10 of
         0:S:=S+' '+Kop5_0;
         1:S:=S+' '+Kop1;
         2..4:S:=S+' '+Kop2_4;
       else
         S:=S+' '+Kop5_0;
       end;
  end
  else S:=' 00 '+Kop5_0;
  if Sum=0 then S:=Zerro+' '+Rub5_0+S
  else
  begin
    //
    Kop:=Trunc(Sum-(int(Sum/1000)*1000));
    Sum:=int(Sum/1000);
    S1:=Convert3Bits(Kop, false);
    if (Kop mod 100) in [11..19] then
       S:=S1+Rub5_0+S
    else
    case Kop mod 10 of
       1:S:=S1+Rub1+S;
       2..4:S:=S1+Rub2_4+S;
    else
      S:=S1+Rub5_0+S;
    end;
    //
    if Sum<>0 then
    begin
      Kop:=Trunc(Sum-(int(Sum/1000)*1000));
      Sum:=int(Sum/1000);
      if Kop<>0 then
      begin
        S1:=Convert3Bits(Kop, true);
        if (Kop div 10) mod 10 = 1 then
          S:=S1+Rub5_0000+S
        else
        case Kop mod 10 of
           1:S:=S1+Rub1000+S;
           2..4:S:=S1+Rub2_4000+S;
        else
          S:=S1+Rub5_0000+S;
        end;
      end;
      //
      if Sum<>0 then
      begin
        Kop:=Trunc(Sum-(int(Sum/1000)*1000));
        Sum:=int(Sum/1000);
        if Kop<>0 then
        begin
          S1:=Convert3Bits(Kop, false);
          if (Kop div 10) mod 10 = 1 then
            S:=S1+RM5_0+S
          else
          case Kop mod 10 of
             1:S:=S1+RM1+S;
             2..4:S:=S1+RM2_4+S;
          else
            S:=S1+RM5_0+S;
          end;
        end;
        if Sum<>0 then
        begin
          Kop:=Trunc(Sum-(int(Sum/1000)*1000));
  {   }
  {        Sum:=int(Sum/1000);}
          S1:=Convert3Bits(Kop, false);
          if (Kop div 10) mod 10 = 1 then
            S:=S1+RMM5_0+S
          else
          case Kop mod 10 of
             1:S:=S1+RMM1+S;
             2..4:S:=S1+RMM2_4+S;
          else
            S:=S1+RMM5_0+S;
          end;
        end;
      end;
    end;
  end;
{$IFDEF TARGET_DOS}
  PriceToString:=stUpCase(S[1])+Copy(S,2,Length(S));
{$ELSE}
  PriceToString:=AnsiUpperCase(S[1])+Copy(S,2,Length(S));
{$ENDIF}
end;*)

end.
